#include "main.h"

#define N_MOB 0
#define B_MOB 1
#define R_MOB 2


void eval_reinit () //       
{
    int i, j;
    U64 x64;

    // 012345678901
    // pPnNbBrRqQkK

    #ifdef SOFT_CONTROL
    //         ( Rebel),   
    int cnt, val;

    for (int bi = 0; bi < 256; bi ++)
    {
        for (int wi = 0; wi < 256; wi ++)
        {
            //  : (     )

            //  hi
            //   15     14     13     12   |  11     10      9      8
            //  King   Queen  Rook   Rook  |      Total piece count

            //  lo
            //    7      6      5      4   |   3      2      1      0
            //  Bishop Knight Knight Pawn  |      Total piece count

            val = 0;

            cnt = (wi & 15) - (bi & 15); //     (?!)

            //      
            if (cnt > 7) cnt = 7;
            if (cnt < -7) cnt = -7;
            cnt = (cnt > 0) ? SYNERGY(cnt) : -SYNERGY(-cnt);

            //     
            i = bi & (1 << 4);
            j = wi & (1 << 4);
            if (i == j)
            {
                i = pop_count (bi & (3 << 5));
                j = pop_count (wi & (3 << 5));
                if (i == j)
                {
                    i = bi & (1 << 7);
                    j = wi & (1 << 7);
                    if (i == j)
                    {
                        //      
                        //   ,       
                        val = 0;
                    }
                    else val = ((i > j) ? - CONTROL_B : CONTROL_B) + cnt;
                }
                else val = ((i > j) ? - CONTROL_N : CONTROL_N) + cnt;
            }
            else val = ((i > j) ? - CONTROL_P : CONTROL_P) + cnt;

            lo_king_att [bi][wi] = val;
            lo_weak_att [bi][wi] = val / 8;


            //     
            i = pop_count (bi & (3 << 4));
            j = pop_count (wi & (3 << 4));
            if (i == j)
            {
                i = bi & (1 << 6);
                j = wi & (1 << 6);
                if (i == j)
                {
                    i = bi & (1 << 7);
                    j = wi & (1 << 7);
                    if (i == j)
                    {
                        //    (   ,     
                        //  )     
                        val = cnt;
                    }
                    else val = ((i > j) ? - CONTROL_K : CONTROL_K) + cnt;
                }
                else val = ((i > j) ? - CONTROL_Q : CONTROL_Q) + cnt;
            }
            else val = ((i > j) ? - CONTROL_R : CONTROL_R) + cnt;

            hi_king_att [bi][wi] = 2 * val;
            hi_weak_att [bi][wi] = val;
        };
    };
    #endif

    // 
	for (i = 0; i < 64; i ++) //  
	{
	    tropism_calc (i, KNIGHT_ID);
	    tropism_calc (i, BISHOP_ID);
	    tropism_calc (i, ROOK_ID);
	    tropism_calc (i, QUEEN_ID);
	};

	//  PST
	init_pst ();
};

void eval_init ()
{
    int i, j, k, s;
    int x, y;
    int d;  // depth (ONE_PLY == 2)
    int hd; // half depth (ONE_PLY == 1)
    int mc; // moveCount
    U64 x64;

    //  
    for (i = 0; i < 64; i ++)
    {
        for (j = 0; j < 64; j ++)
        {
            x = absu (hori(i), hori(j));
            y = absu (vert(i), vert(j));

            on_line [i][j] = !((i ^ j) & 070) || !((i ^ j) & 007);
            on_diag [i][j] = (x == y);
        };
    };

    //     
    for (i = 0; i < 64; i ++)
    {
        w_att_frontspan [i]  = fill_up (wpawn_att [i]);
        b_att_frontspan [i]  = fill_dn (bpawn_att [i]);
        w_wide_frontspan [i] = fill_up ((I << i) | wpawn_att [i]);
        b_wide_frontspan [i] = fill_dn ((I << i) | bpawn_att [i]);
    };

    //  
    for (x = 0; x < 8; x ++)
    {
        for (y = 0; y < 8; y ++)
        {
            k = compose (x, y);
            n_mobility [k] = knight_att [k]; //    - 1  , 1  

            //      1    
            b_mobility [k] = E;
            for (s = 0, i = x, j = y; i < 8 && j < 8 && s < 1; i ++, j ++, s++) b_mobility [k] |= I << compose (i, j);
            for (s = 0, i = x, j = y; i >= 0 && j < 8 && s < 1; i --, j ++, s++) b_mobility [k] |= I << compose (i, j);
            for (s = 0, i = x, j = y; i < 8 && j >= 0 && s < 1; i ++, j --, s++) b_mobility [k] |= I << compose (i, j);
            for (s = 0, i = x, j = y; i >= 0 && j >= 0 && s < 1; i --, j --, s++) b_mobility [k] |= I << compose (i, j);

            b_mobility [k] ^= I << k;

            //       ,    
            r_mobility [k] = E;
            for (s = 0, i = x, j = y; i < 8 && s < 1; i ++, s++) r_mobility [k] |= I << compose (i, j);
            for (s = 0, i = x, j = y; i >= 0 && s < 1; i --, s++) r_mobility [k] |= I << compose (i, j);
            //for (s = 0, i = x, j = y; i < 8 && i >= 0 && j < 8 && j >= 0 && s < 1; i ++, j ++, s++) r_mobility [k] |= I << compose (i, j);
            //for (s = 0, i = x, j = y; i < 8 && i >= 0 && j < 8 && j >= 0 && s < 1; i ++, j ++, s++) r_mobility [k] |= I << compose (i, j);

            r_mobility [k] ^= I << k;
        };
    };

    //   
    for (i = 0; i < 64; i ++) un_castling [i] = c_k | c_q | c_K | c_Q;

	un_castling [A1] = c_k | c_q | c_K       ;
	un_castling [H1] = c_k | c_q       | c_Q ;
	un_castling [A8] = c_k       | c_K | c_Q ;
	un_castling [H8] =       c_q | c_K | c_Q ;

	un_castling [E1] = c_k | c_q             ;
	un_castling [E8] =             c_K | c_Q ;

	//        
    bad_rook [A1] = bad_rook [A2] = bad_rook [A3] = bad_rook [A4] = _A1 | _A2 | _A3;
    bad_rook [B1] = bad_rook [B2] = bad_rook [B3] = bad_rook [B4] = _A1 | _A2 | _A3 | _B1 | _B2 | _B3;
    bad_rook [B1] = bad_rook [B2] = bad_rook [C3] = bad_rook [C4] = _A1 | _A2 | _A3 | _B1 | _B2 | _B3 | _C1 | _C2 | _C3;
    bad_rook [D1] = bad_rook [D2] = bad_rook [D3] = bad_rook [D4] = _A1 | _A2 | _A3 | _B1 | _B2 | _B3 | _C1 | _C2 | _C3 | _D1 | _D2 | _D3;
    bad_rook [E1] = bad_rook [E2] = bad_rook [E3] = bad_rook [E4] = _H1 | _H2 | _H3 | _G1 | _G2 | _G3 | _F1 | _F2 | _F3 | _E1 | _E2 | _E3;
    bad_rook [F1] = bad_rook [F2] = bad_rook [F3] = bad_rook [F4] = _H1 | _H2 | _H3 | _G1 | _G2 | _G3 | _F1 | _F2 | _F3;
    bad_rook [G1] = bad_rook [G2] = bad_rook [G3] = bad_rook [G4] = _H1 | _H2 | _H3 | _G1 | _G2 | _G3;
    bad_rook [H1] = bad_rook [H2] = bad_rook [H3] = bad_rook [H4] = _H1 | _H2 | _H3;

    bad_rook [A8] = bad_rook [A7] = bad_rook [A6] = bad_rook [A5] = _A8 | _A7 | _A6;
    bad_rook [B8] = bad_rook [B7] = bad_rook [B6] = bad_rook [B5] = _A8 | _A7 | _A6 | _B8 | _B7 | _B6;
    bad_rook [C8] = bad_rook [C7] = bad_rook [C6] = bad_rook [C5] = _A8 | _A7 | _A6 | _B8 | _B7 | _B6 | _C8 | _C7 | _C6;
    bad_rook [D8] = bad_rook [D7] = bad_rook [D6] = bad_rook [D5] = _A8 | _A7 | _A6 | _B8 | _B7 | _B6 | _C8 | _C7 | _C6 | _D8 | _D7 | _D6;
    bad_rook [E8] = bad_rook [E7] = bad_rook [E6] = bad_rook [E5] = _H8 | _H7 | _H6 | _G8 | _G7 | _G6 | _F8 | _F7 | _F6 | _E8 | _E7 | _E6;
    bad_rook [F8] = bad_rook [F7] = bad_rook [F6] = bad_rook [F5] = _H8 | _H7 | _H6 | _G8 | _G7 | _G6 | _F8 | _F7 | _F6;
    bad_rook [G8] = bad_rook [G7] = bad_rook [G6] = bad_rook [G5] = _H8 | _H7 | _H6 | _G8 | _G7 | _G6;
    bad_rook [H8] = bad_rook [H7] = bad_rook [H6] = bad_rook [H5] = _H8 | _H7 | _H6;

    //   
    for (i = 0; i < 256; i ++)
    {
        x64 = i;
        x64 |= x64 << 8;
        x64 |= x64 << 16;
        x64 |= x64 << 32;

        expand [i] = x64;
    };

    for (i = 0; i < 64; i ++) up_mask [i] = UPMASK << ((hori(i)) << 3);
    for (i = 0; i < 64; i ++) dn_mask [i] = DNMASK >> ((7 - (hori(i))) << 3);


    // Init reductions array
    for (hd = 1; hd < 64; hd++) for (mc = 1; mc < 64; mc++)
    {
        double    pvRed = 0.33 + log(double(hd)) * log(double(mc)) / 4.5;
        double nonPVRed = 0.33 + log(double(hd)) * log(double(mc)) / 2.25;
        reductions[1][hd][mc] =    pvRed >= 1.0 ? floor(   pvRed) : 0;
        reductions[0][hd][mc] = nonPVRed >= 1.0 ? floor(nonPVRed) : 0;
    };

    // , ,   //////////////////////////////////////////////////////////////
    eval_reinit ();
};

void init_material_table ()
{
    int score, overload;
    int index, phase, type;
    int stage[2];
    int wq, wr, wb, wn, wp;
    int bq, br, bb, bn, bp;
    int w_min, b_min;
    int w_maj, b_maj;
    int w_maj_score, b_maj_score;
    int w_tot_score, b_tot_score;
    int mul;

    for (wq = 0; wq < 3; wq ++)
	for (bq = 0; bq < 3; bq ++)
	for (wr = 0; wr < 3; wr ++)
	for (br = 0; br < 3; br ++)
	for (wb = 0; wb < 3; wb ++)
	for (bb = 0; bb < 3; bb ++)
	for (wn = 0; wn < 3; wn ++)
	for (bn = 0; bn < 3; bn ++)
	for (wp = 0; wp < 9; wp ++)
	for (bp = 0; bp < 9; bp ++)
	{
		index  = wp * MAT_WP + wn * MAT_WN + wb * MAT_WB + wr * MAT_WR + wq * MAT_WQ;
		index += bp * MAT_BP + bn * MAT_BN + bb * MAT_BB + br * MAT_BR + bq * MAT_BQ;

        stage[0] = min (16, (bn + bb) + 3 * br + 6 * bq);
        stage[1] = min (16, (wn + wb) + 3 * wr + 6 * wq);
        phase = stage[0] + stage[1];
        w_min = wb + wn;
        b_min = bb + bn;
        w_maj = wq + wr;
        b_maj = bq + br;
        w_maj_score = 5 * wr + 10 * wq;
        b_maj_score = 5 * br + 10 * bq;
        w_tot_score = w_maj_score + 3 * w_min;
        b_tot_score = b_maj_score + 3 * b_min;
        //wmat = wmul = 15;
        //bmat = bmul = 15;

        mul = 32; // 
        type = EVAL_USUAL;

        if (wp == 0 && bp == 0) //  
        {
            if (phase < 2) mul = 0; // KK, KLK (L - light)
            else if (phase == 2) // KLLK, KLKL
            {
                if (w_min == 1 && b_min == 1)
                {
                    mul = 1;
                    if (wb == 1 && bb == 1) type = EVAL_BISHOPS;
                }
                else if (wn == 2 || bn == 2) mul = 1;
                else if (wb == 2 || bb == 2) {mul = 30; type = EVAL_KBBK;}
                else {mul = 28; type = EVAL_KBNK;};
            }
            else if (phase == 3) // KRK, KLLLK, KLLKL, ...
            {
                if (wr || br) mul = 32;
                else if (w_min == 3 || b_min == 3) mul = 32;
                else mul = 3;
            }
            else if (phase == 4) // KRKN, KRKB, KLLLLK, ...
            {
                if (wr)
                {
                    if (bn) {mul = 8; type = EVAL_KRKN;}
                    else if (bb) mul = 6;
                }
                else if (br)
                {
                    if (wn) {mul = 8; type = EVAL_KRKN;}
                    else if (wb) mul = 6;
                }
                else if (w_min == 4 || b_min == 4) mul = 32;
                else if (w_min == 3 || b_min == 3) mul = 18;
                else if (w_min == 2 || b_min == 2) mul = 5;
            }
            else if (phase == 6) // KRKR
            {
                if (wr && br) mul = 1;
            }
            else if (phase == 7) // KQKN, KQKB
            {
                if (wq)
                {
                    if (bn) mul = 17;
                    else if (bb) mul = 24;
                }
                else if (bq)
                {
                    if (wn) mul = 17;
                    else if (wb) mul = 24;
                };
            }
            else if (phase == 9) // KQKR
            {
                if ((wq && br) || (bq && wr)) {mul = 10; type = EVAL_KQKR;};
            }
            else if (phase == 12) // KQKQ
            {
                if (wq && bq) mul = 2;
            };
        };

        if (wp == 1 && bp == 0) //    ()
        {
            if (phase == 0) // KPK
            {
                mul = 16;
                type = EVAL_KPK;
            }
            else if (phase == 1) // KPLK, KPKL
            {
                if (w_min) mul = 27;
                else if (b_min) mul = 5;
            }
            else if (phase == 2) // KPLLK, KPLKL, KPKLL
            {
                if (w_min == 2) mul = 32;
                else if (w_min == 1) mul = 4;
                else
                {
                    if (bn == 2) mul = 6;        // KPKNN
                    else if (bn == 1) mul = 11; // KPKNB
                    else mul = 8;              // KPKBB
                };
            }
            else if (phase == 3) // KPRK, KPKR, KPKLLL, ...
            {
                if (br) {mul = 16; type = EVAL_KRKP;};
            }
            else if (phase == 6) // KPQK, KPKQ, ...
            {
                if (bq) {mul = 20; type = EVAL_KQKP;};
            };
        };

        if (bp == 1 && wp == 0) //    ()
        {
            if (phase == 0) // KPK
            {
                mul = 16;
                type = EVAL_KPK;
            }
            else if (phase == 1) // KPLK, KPKL
            {
                if (b_min) mul = 27;
                else if (w_min) mul = 5;
            }
            else if (phase == 2) // KPLLK, KPLKL, KPKLL
            {
                if (b_min == 2) mul = 32;
                else if (b_min == 1) mul = 4;
                else
                {
                    if (wn == 2) mul = 6;        // KPKNN
                    else if (wn == 1) mul = 11; // KPKNB
                    else mul = 8;              // KPKBB
                };
            }
            else if (phase == 3) // KPRK, KPKR, KPKLLL, ...
            {
                if (wr) {mul = 16; type = EVAL_KRKP;};
            }
            else if (phase == 6) // KPQK, KPKQ, ...
            {
                if (wq) {mul = 20; type = EVAL_KQKP;};
            };
        };

        if (wb == 1 && bb == 1 && w_min == 1 && b_min == 1 && !w_maj && !b_maj) type = EVAL_BISHOPS;

        score  = wp * w_p + wn * w_n + wb * w_b + wr * w_r + wq * w_q;
        score -= bp * b_p + bn * b_n + bb * b_b + br * b_r + bq * b_q;

        score *= mul;
        score /= 32;

        overload = 0; // ,  ,   

        if (wq == 2) overload |= (1 << 7);
        if (wr == 2) overload |= (1 << 6);
        if (wb == 2) overload |= (1 << 5);
        if (wn == 2) overload |= (1 << 4);

        if (bq == 2) overload |= (1 << 3);
        if (br == 2) overload |= (1 << 2);
        if (bb == 2) overload |= (1 << 1);
        if (bn == 2) overload |= (1 << 0);

        //printf ("%i %i %i\n", score, type, overload);

        //    :
        //  SSSSSSSSSSSSSSSS|TTTTTTTT|OOOOOOOO - 32 
        //                            QRBNqrbn
        //  ,  S - 
        //        T -   
        //        O -   
        mat_table [index].score = score;
        mat_table [index].type = type;
        mat_table [index].overload = overload;
        mat_table [index].stage[0] = stage[0];
        mat_table [index].stage[1] = stage[1];
	};
};

//        ( J   !)
//     , , 
inline int xray (int pice, int sq)
{
    int b_sq, x_sq; //      
    int b_pi, x_pi; //  --//--
    int add = 0;
    int val = 0;
    int mat_own;    //   
    int mat_gain;
    int type, col;  // ,  
    U64 t, p, occ;
    U64 blc, xry;   //      ( 1 )

    // 0 -  
    // 1 - 
    // 2 - 
    // 3 - 
    // 4 - skewer

    //   [][]
    static const int pin_rq [6][6] = {{0, 0, 0, 0, 1, 3},
                                      {0, 0, 0, 0, 1, 3},
                                      {0, 0, 0, 0, 1, 3},
                                      {0, 0, 0, 0, 2, 2},
                                      {4, 4, 4, 4, 4, 2},
                                      {4, 4, 4, 4, 4, 0}};

    //   [][]
    static const int pin_bq [6][6] = {{0, 0, 0, 1, 1, 3},
                                      {0, 0, 0, 1, 1, 3},
                                      {0, 0, 0, 2, 2, 2},
                                      {4, 4, 4, 4, 1, 3},
                                      {4, 4, 4, 4, 4, 2},
                                      {4, 4, 4, 4, 4, 0}};

    mat_own = material [pice];

    type = pice >> 1;
    col = pice & 1;

    //   ?
    if (type > BISHOP_ID) //  
    {
        occ = J->occ ^ J->rq[col];  //       ()

        //  
        blc = r_att (occ, sq) & occ;

        //    
        occ ^= blc;
        xry = r_att (occ, sq) & occ & P->occupied[!col]; //    

        for (; xry; xry ^= t)
        {
            t    = LSB (xry);
            x_sq = bitscan (t);
            x_pi = P->squares [x_sq];

            //  
            p    = link_att [x_sq][sq] & blc;
            b_sq = bitscan (p);
            b_pi = P->squares [b_sq];

            if (piece_col(b_pi) == col) //  
            {
                // .. 
                if (piece_id(x_pi) == KING_ID) add = _DISC_CHECK;
                else
                {
                    // .. 
                    mat_gain = material[x_pi] - mat_own;
                    if (mat_gain > 0) add = _DISC_ATT;
                };
            }
            else //  |
            {
                //   skewer
                switch (pin_rq [piece_id(b_pi)][piece_id(x_pi)])
                {
                    case 1: // 
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN;
                        break;
                    case 2: //  
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN_PART;
                        break;
                    case 3: //  
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN_ABS;
                        break;
                    case 4: // Skewer
                        mat_gain = material[b_pi] - mat_own; // blocker!
                        if (mat_gain > 0) add = _SKEWER;
                        break;
                };
            };

            //    
            //if (vert(x_sq) == vert(sq) && b_pi < 2) add /= 2;

            val += add;
        };
    };

    if (type != ROOK_ID) //  
    {
        occ = J->occ ^ J->bq[col]; //       ()

        //  
        blc = b_att (occ, sq) & occ;

        //    
        occ ^= blc;
        xry = b_att (occ, sq) & occ & P->occupied[!col]; //    

        for (; xry; xry ^= t)
        {
            t    = LSB (xry);
            x_sq = bitscan (t);
            x_pi = P->squares [x_sq];

            //  
            p    = link_att [x_sq][sq] & blc;
            b_sq = bitscan (p);
            b_pi = P->squares [b_sq];

            if (piece_col(b_pi) == col) //  
            {
                // .. 
                if (piece_id(x_pi) == KING_ID) add = _DISC_CHECK;
                else
                {
                    // .. 
                    mat_gain = material[x_pi] - mat_own;
                    if (mat_gain > 0) add = _DISC_ATT;
                };
            }
            else //  |
            {
                //   skewer
                switch (pin_bq [piece_id(b_pi)][piece_id(x_pi)])
                {
                    case 1: // 
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN;
                        break;
                    case 2: //  
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN_PART;
                        break;
                    case 3: //  
                        mat_gain = material[x_pi] - mat_own; // xrayer
                        if (mat_gain > 0) add = _PIN_ABS;
                        break;
                    case 4: // Skewer
                        mat_gain = material[b_pi] - mat_own; // blocker!
                        if (mat_gain > 0) add = _SKEWER;
                        break;
                };
            };

            val += add;
        };
    };

    return val;
};

inline int calc_w_king_stage (board * B)
{
    int val = 0;
    int i, tmp;
    int sk, sq;  //       
    int badrook; //  
    U64 bb, x64;

    // 
    badrook = 0;
    sk = sq = 2;

    i = WK;
    bb = P->piece [i];

    //     (       )
    if (J->q_is[0] /* || J->king_stage[0] */)
    {
        //  
        badrook = ( P->piece[WR] & bad_rook[ J->king_sq[1] ] );

        //      
        if (B->castling_rights & c_K)
        {
            //        (1 - )
            sk = 4 - pop_count (J->occ & c_mov_K);
        }
        else
        {
            //   
            if (!badrook)
            {
                if      (bb & (_G1 | _H1)) sk = 6;
                else if (bb & (_G2 | _H2)) sk = 5;
            }
            else sk = 0;
        };

        //      
        if (B->castling_rights & c_Q)
        {
            //       
            sq = 4 - pop_count (J->occ & c_mov_Q);
        }
        else
        {
            //   
            if (!badrook)
            {
                if (bb & (_C1 | _A2 | _B2)) sq = 5;
                else if (bb  & (_A1 | _B1)) sq = 6;
            }
            else sq = 0;
        };

        tmp = max (sk, sq);
        J->king_stage[1] = (tmp > 4) ? tmp : (sk >= 2 ? sk : (sk + sq) / 2);
    }
    else J->king_stage[1] = 6;

    if (J->king_stage[0] > 4 && badrook) val -= BAD_ROOK;

    val += KING_DEV (J->king_stage[1]);

    return val;
};

inline int calc_b_king_stage (board * B)
{
    int val = 0;
    int i, tmp;
    int sk, sq;  //       
    int badrook; //  
    U64 bb, x64;

    // ׸
    badrook = 0;
    sk = sq = 2;

    i = BK;
    bb = P->piece [i];

    //    
    if (J->q_is[1])
    {
        //  
        badrook = P->piece[BR] & bad_rook[ J->king_sq[0] ];

        //      
        if (B->castling_rights & c_k)
        {
            //        (1 - )
            sk = 4 - pop_count (J->occ & c_mov_k);
        }
        else
        {
            //   
            if (!badrook)
            {
                if      (bb & (_G8 | _H8)) sk = 6;
                else if (bb & (_G7 | _H7)) sk = 5;
            }
            else sk = 0;
        };

        //      
        if (B->castling_rights & c_q)
        {
            //       
            sq = 4 - pop_count (J->occ & c_mov_q);
        }
        else
        {
            //   
            if (!badrook)
            {
                if (bb & (_C8 | _A7 | _B7)) sq = 5;
                else if (bb  & (_A8 | _B8)) sq = 6;
            }
            else sq = 0;
        };

        tmp = max (sk, sq);
        J->king_stage[0] = (tmp > 4) ? tmp : (sk >= 2 ? sk : (sk + sq) / 2);
    }
    else J->king_stage[0] = 6;

    if (J->king_stage[0] > 4 && badrook) val -= BAD_ROOK;

    val += KING_DEV (J->king_stage[0]);

    return val;
};

//  
inline int eval_w_king (board * B)
{
    int i, j, jj;
    int val = 0;
    U64 bb, bbb;
    U64 t, x64;
    U64 tt;

    //  ( ,      )
    if (J->stage[0] < STAGE_EG && J->rq[0])
    {
        if (bb & (_A1 | _B1 | _C1)
        &&  P->piece[WP] & _A2
        &&  P->piece[WP] & _B2)
        {
            val -= CLOSED_KING;
        };

        if (bb & (_G1 | _H1)
        &&  P->piece[WP] & _G2
        &&  P->piece[WP] & _H2)
        {
            val -= CLOSED_KING;
        };
    };

    t = LSB (bb);
    j = bitscan (t);

    // Scaling
    val += (pst [WK][j] * J->stage[0] + pst [WK + 2][j] * (16 - J->stage[0])) / 16;

    // Soft Control ///////////////////////////////////////////////////////////////////

    #ifdef SOFT_CONTROL
    if (J->king_stage [0] > 4)
    {
        for (bbb = J->king_safety[1] & ~J->no_atts; bbb; bbb ^= tt)
        {
            tt = LSB (bbb);
            jj = bitscan (tt);

            val += min (0, val_att_king (J->atts[jj]));
        };

        for (bbb = (J->targets[0] | J->passers[1]) & ~J->no_atts; bbb; bbb ^= tt)
        {
            tt = LSB (bbb);
            jj = bitscan (tt);

            val += min (0, val_att_weak (J->atts[jj]));
        };
    };
    #endif

    return val;
};

// ׸ 
inline int eval_b_king (board * B)
{
    int i, j, jj;
    int val = 0;
    U64 bb, bbb;
    U64 t, x64;
    U64 tt;

    //  ( ,      )
    if (J->stage[1] < STAGE_EG && J->rq[1])
    {
        if (bb & (I << A8 | I << B8 | I << C8)
        &&  P->piece[BP] & (I << A7)
        &&  P->piece[BP] & (I << B7))
        {
            val -= CLOSED_KING;
        };

        if (bb & (I << G8 | I << H8)
        &&  P->piece[BP] & (I << G7)
        &&  P->piece[BP] & (I << H7))
        {
            val -= CLOSED_KING;
        };
    };

    t = LSB (bb);
    j = bitscan (t);

    // Scaling
    val += (pst [BK][j] * J->stage[1] + pst [BK + 2][j] * (16 - J->stage[1])) / 16;

    // Soft Control ///////////////////////////////////////////////////////////////////

    #ifdef SOFT_CONTROL
    if (J->king_stage [1] > 4)
    {
        for (bbb = J->king_safety[0] & ~J->no_atts; bbb; bbb ^= tt)
        {
            tt = LSB (bbb);
            jj = bitscan (tt);

            val += max (0, val_att_king (J->atts[jj]));
        };

        for (bbb = (J->targets[1] | J->passers[0]) & ~J->no_atts; bbb; bbb ^= tt)
        {
            tt = LSB (bbb);
            jj = bitscan (tt);

            val += max (0, val_att_weak (J->atts[jj]));
        };
    };
    #endif

    return val;
};

inline int eval_w_pawns ()
{
    int i, j;
    int val = 0;
    U64 bb, t, t1;
    U64 bbb, x64;

    i = WP;
    bb = P->piece [i];

    // 
    t = fill_up (bb);
    t1 = fill_dn (bb);

    J->ofiles[1] = ~(t | t1);
    t <<= 8;

    // 
    for (bbb = t & bb; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        j = bitscan (t);

        val -= DOUBLED (vert(j));
    };

    //  -    
    t = (bb << 8) & ~J->pawn_att[1];
    val -= HOLES * pop_count (t);
    J->targets[0] |= (t >> 8);

    //  
    t = ~fill_up (J->pawn_att[1]) & J->pawn_att[0];
    t = fill_dn (t) & bb;
    val -= BACKWARD * pop_count (t);
    J->targets[0] |= t;

    //  
    t = bb & ( J->pawn_att[1] | csl(bb, 1) | csr(bb, 1) );
    J->targets[0] |= bb & ~t;

    //    
    //J->targets[0] = bb & (~J->pawn_att[1]) & (P->piece[BP] >> 8);
    //val -= (BLOCKED / 2) * pop_count (J->targets[0]); // :  - 1/2,  - 0

    //    
    //J->targets[0] |= bb & (~J->pawn_att[1]) & ((P->occupied[0] ^ P->piece[BP]) >> 8);
    //val -= (BLOCKED / 2) * pop_count (J->targets[0]); // :  - 1/2,  - 1/2

    //  
    t = ~J->ofiles[1];
    t = bb & ( ~csl(t, 1) & t & ~csr(t, 1) );
    val -= ISOLATED * pop_count (t);
    J->targets[0] |= t;

    // 
    val += MCENTER (pop_count ((bb | J->pawn_att[1]) & CENTER));
    //val += BCENTER (pop_count (bb & W_BIG_CENTER));

    //   
    bb &= P->occupied[1] >> 8;
    bb &= (rank_2 | rank_3) & (file_d | file_e);
    val -= BLOCKED_PAWN * pop_count (bb);

    bb = P->piece [WK];
    J->shield[1] = 0;

    //  
    if      (bb & K_SIDE) bbb = P->piece [WP] & (W_SHIELD_MASK & K_SIDE);
    else if (bb & Q_SIDE) bbb = P->piece [WP] & (W_SHIELD_MASK & Q_SIDE);
    else                  bbb = E;

    for (; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        J->shield[1] += SHIELD (wshield_sq [bitscan (t)]);
    };

    //  
    if      (bb & K_SIDE) bbb = P->piece [BP] & (W_SHIELD_MASK & K_SIDE);
    else if (bb & Q_SIDE) bbb = P->piece [BP] & (W_SHIELD_MASK & Q_SIDE);
    else                  bbb = E;

    for (; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        J->shield[1] -= STORM (wshield_sq [bitscan (t)]);
    };

    return val;
};

inline int eval_b_pawns ()
{
    int i, j;
    int val = 0;
    U64 bb, t, t1;
    U64 bbb, x64;

    i = BP;
    bb = P->piece [i];

    // 
    t = fill_dn (bb);
    t1 = fill_up (bb);

    J->ofiles[0] = ~(t | t1);
    t >>= 8;

    // 
    for (bbb = t & bb; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        j = bitscan (t);

        val -= DOUBLED (vert(j));
    };

    //  -    
    t = (bb >> 8) & ~J->pawn_att[0];
    val -= HOLES * pop_count (t);
    J->targets[1] |= (t << 8);

    //  
    t = ~fill_dn (J->pawn_att[0]) & J->pawn_att[1];
    t = fill_up (t) & bb;
    val -= BACKWARD * pop_count (t);
    J->targets[1] |= t;

    //  
    t = bb & ( J->pawn_att [0] | csl(bb, 1) | csr(bb, 1) );
    J->targets[0] |= bb & ~t;

    //     -  
    //J->targets[1] = bb & (~J->pawn_att [0]) & (P->piece[WP] << 8);
    //val -= (BLOCKED / 2) * pop_count (J->targets[1]); // :  - 1/2,  - 0

    //     -   
    //J->targets[1] |= bb & (~J->pawn_att [0]) & ((P->occupied[1] ^ P->piece[WP]) << 8);
    //val -= (BLOCKED / 2) * pop_count (J->targets[1]); // :  - 1/2,  - 1/2

    //  
    t = ~J->ofiles[0];
    t = bb & ( ~csl(t, 1) & t & ~csr(t, 1) );
    val -= ISOLATED * pop_count (t);
    J->targets[0] |= t;

    //      - 
    //if (J->stage[1] <= STAGE_EG
    //&&  bb & W_HALF) BVALUE_ADD (val, 1, _PAWN_ON_OPP_SIDE);// val += PAWN_ON_OPP_SIDE;

    // 
    val += MCENTER (pop_count ((bb | J->pawn_att[0]) & CENTER));
    //val += bcenter_cntrl [pop_count (bb & B_BIG_CENTER)];

    //   
    bb &= P->occupied[0] << 8;
    bb &= (rank_7 | rank_6) & (file_d | file_e);
    val -= BLOCKED_PAWN * pop_count (bb);

    bb = P->piece [BK];
    J->shield[0] = 0;

    //  
    if      (bb & K_SIDE) bbb = P->piece [BP] & (B_SHIELD_MASK & K_SIDE);
    else if (bb & Q_SIDE) bbb = P->piece [BP] & (B_SHIELD_MASK & Q_SIDE);
    else                  bbb = E;

    for (; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        J->shield[0] += SHIELD (bshield_sq [bitscan (t)]);
    };

    //  
    if      (bb & K_SIDE) bbb = P->piece [WP] & (B_SHIELD_MASK & K_SIDE);
    else if (bb & Q_SIDE) bbb = P->piece [WP] & (B_SHIELD_MASK & Q_SIDE);
    else                  bbb = E;

    for (; bbb; bbb ^= t)
    {
        t = LSB (bbb);
        J->shield[0] -= STORM (bshield_sq [bitscan (t)]);
    };

    return val;
};

inline int eval_w_passers ()
{
    int j, diff = 0;
    int val = 0;
    U64 bb, t;
    U64 sentry;
    U64 helper;

    //     -    
    J->passers[1] = P->piece[WP] & J->ofiles[0];
    J->att_def |= J->passers[1];

    for (bb = J->passers[1]; bb; bb ^= t)
    {
        t = LSB (bb);
        j = bitscan (t);

        sentry = (w_att_frontspan [j] << 8) & P->piece[BP];

        if (!sentry) //  ,  
        {
            if (!J->stage[0])
            {
                //        
                //     ,    
                if (manh (J->king_sq[0], j | 070) - P->wtm > 9 - hori(j))
                {
                    val += FRE_PASSER (hori(j));
                    continue;
                };
            };

            if (J->pawn_att[1] & t)
            {
                val += DEF_PASSER (hori(j));
                continue;
            };

            val += PASSER (hori(j));
            continue;
        };

        if (t & W_HALF) continue; //    5 

        helper = (csr(t, 1) | csl(t, 1)) & P->piece[WP];

        for (; sentry; sentry ^= LSB(sentry)) diff ++;
        for (; helper; helper ^= LSB(helper)) diff --;

        if (diff <= 0) val += PASSER (hori(j)) / 2; // 
        else J->passers[1] ^= t;

    };

    return val;
};


inline int eval_b_passers ()
{
    int j, diff = 0;
    int val = 0;
    U64 bb, t;
    U64 sentry;
    U64 helper;

    //     -    
    J->passers[0] = P->piece[BP] & J->ofiles[1];
    J->att_def |= J->passers[0];
    //print_this_att (J->passers[0]);

    for (bb = J->passers[0]; bb; bb ^= t)
    {
        t = LSB (bb);
        j = bitscan (t);

        sentry = (b_att_frontspan [j] >> 8) & P->piece[WP];
        //print_this_att (sentry);

        if (!sentry) //  ,  
        {
            if (!J->stage[1])
            {
                //        
                //     ,    
                if (manh (J->king_sq[1], j & 007) - P->wtm > hori(j) + 1)
                {
                   val += FRE_PASSER (7 - hori(j));
                    continue;
                };
            };

            if (J->pawn_att[0] & t)
            {
                val += DEF_PASSER (7 - hori(j));
                continue;
            };

            val += PASSER (7 - hori(j));
            continue;
        };

        if (t & B_HALF) continue; //    4 

        helper = (csr(t, 1) | csl(t, 1)) & P->piece[BP];

        for (; sentry; sentry ^= LSB(sentry)) diff ++;
        for (; helper; helper ^= LSB(helper)) diff --;

        if (diff <= 0) val += PASSER (7 - hori(j)) / 2; // 
        else J->passers[0] ^= t;

    };

    return val;
};

inline int eval_w_knights ()
{
    int i, j, f;
    int val = 0;
    U64 t, x64, bbb;
    U64 bb, att;

    f = CTRL_WN1;
    i = WN;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        att = knight_att [j];

        // 
        if (t & W_OUTPOST
        &&  t & J->pawn_att[1]
        && !(w_att_frontspan [j] & P->piece[BP])) val += N_OUTPOST;

        //   
        #ifdef SOFT_CONTROL
        soft_control (f, att);
        #endif

        f <<= 1; //  

        // 
        val += n_trop[J->king_sq[0]][j];

        // 
        bbb = att & J->not_white & ~J->pawn_att[0];

        if (!(bbb & up_mask[j] & n_mobility[j])
        ||  !(bbb & dn_mask[j] & n_mobility[j])) val -= IMMOBILITY (N_MOB);

        // 
        bbb = att & (P->piece[BR] | P->piece[BQ] | P->piece[BK]);
        if (bbb && LSB(bbb)) val += FORK;

        //val += NMOB_F (pop_count (bbb & up_mask [j]));
        //val += NMOB_B (pop_count (bbb & dn_mask [j]));

        bb ^= t;
    };

    return val;
};

inline int eval_b_knights ()
{
    int i, j, f;
    int val = 0;
    U64 t, x64, bbb;
    U64 bb, att;

    f = CTRL_BN1;
    i = BN;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        att = knight_att [j];

        // 
        if (t & B_OUTPOST
        &&  t & J->pawn_att[0]
        && !(b_att_frontspan [j] & P->piece[WP])) val += N_OUTPOST;

        //   
        #ifdef SOFT_CONTROL
        soft_control (f, att);
        #endif

        f <<= 1; //  

        // 
        val += n_trop[J->king_sq[1]][j];

        // 
        bbb = att & J->not_black & ~J->pawn_att[1];

        if (!(bbb & up_mask[j] & n_mobility[j])
        ||  !(bbb & dn_mask[j] & n_mobility[j])) val -= IMMOBILITY(N_MOB);

        // 
        bbb = att & (P->piece[WR] | P->piece[WQ] | P->piece[WK]);
        if (bbb && LSB(bbb)) val += FORK;

        //val += NMOB_F (pop_count (bbb & dn_mask [j]));
        //val += NMOB_B (pop_count (bbb & up_mask [j]));

        bb ^= t;
    };

    return val;
};

inline int eval_w_bishops ()
{
    int i, j, k;
    int val = 0;
    int cnt = 0;
    U64 t;
    U64 x64, bbb;
    U64 bb, att;

    i = WB;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        // PST
        val += pst [i][j];

        // Returning Bishop
        if (J->king_sq[1] == G1 && j == F1) val += RET_BISHOP;
        if (J->king_sq[1] == B1 && j == C1) val += RET_BISHOP;

        att = b_att (J->occ ^ J->bq[1], j);

        cnt ++;

        #ifdef USE_FAST_XRAYS
        val += xray (i, j); // 
        #endif

        #ifdef SOFT_CONTROL
        soft_control (CTRL_WB, att); //   
        #endif

        // 
        val += b_trop[J->king_sq[0]][j];

        // 
        bbb = att & J->not_white & ~J->pawn_att[0];

        //if (bbb & b_mobility[j] != b_mobility[j]) val -= IMMOBILITY (B_MOB);
        //if (!(att & up_mask[j] & b_mobility[j])
        //||  !(att & dn_mask[j] & b_mobility[j])) val -= IMMOBILITY(B_MOB);

        // 
        bbb = att & (P->piece[BR] | P->piece[BQ] | P->piece[BK]);
        if (bbb && LSB(bbb)) val += FORK;

        //val += BMOB_F (pop_count (bbb & up_mask [j]));
        //val += BMOB_B (pop_count (bbb & dn_mask [j]));

        //  
        if (att & up_mask [j] & P->piece[WP]) val -= BAD_BISHOP;

        // 
        if (((P->piece[WP] & (_A2 | _B3)) == (_A2 | _B3)) && (j == B2)) val += FIANCHETTO;
        if (((P->piece[WP] & (_H2 | _G3)) == (_H2 | _G3)) && (j == G2)) val += FIANCHETTO;

        bb ^= t;
    };

    if (cnt > 1) val += BISHOP_PAIR;

    return val;
};

inline int eval_b_bishops ()
{
    int i, j, k;
    int val = 0;
    int cnt = 0;
    U64 t;
    U64 x64, bbb;
    U64 bb, att;

    i = BB;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        // PST
        val += pst [i][j];

        // Returning Bishop
        if (J->king_sq[0] == G8 && j == F8) val += RET_BISHOP;
        if (J->king_sq[0] == B8 && j == C8) val += RET_BISHOP;

        att = b_att (J->occ ^ J->bq[0], j);

        cnt ++;

        #ifdef USE_FAST_XRAYS
        val += xray (i, j); // 
        #endif

        //   
        #ifdef SOFT_CONTROL
        soft_control (CTRL_BB, att);
        #endif

        // 
        val += b_trop [J->king_sq[1]][j];

        // 
        bbb = att & J->not_black & ~J->pawn_att[1];

        //if (bbb & b_mobility[j] != b_mobility[j]) val -= IMMOBILITY (B_MOB);
        //if (!(att & up_mask[j] & b_mobility[j])
        //||  !(att & dn_mask[j] & b_mobility[j])) val -= IMMOBILITY(B_MOB);

        // 
        bbb = att & (P->piece[WR] | P->piece[WQ] | P->piece[WK]);
        if (bbb && LSB(bbb)) val += FORK;

        //val += BMOB_F (pop_count (bbb & dn_mask [j]));
        //val += BMOB_B (pop_count (bbb & up_mask [j]));
        if (bbb & dn_mask [j] & P->piece[BP]) val -= BAD_BISHOP;

        // 
        if (P->piece[BP] & ((_A7 | _B6) == (_A7 | _B6)) && (j == B7)) val += FIANCHETTO;
        if (P->piece[BP] & ((_H7 | _G6) == (_H7 | _G6)) && (j == G7)) val += FIANCHETTO;

        bb ^= t;
    };

    if (cnt > 1) val += BISHOP_PAIR;

    return val;
};

inline int eval_w_rooks ()
{
    int i, j, k, f;
    int val = 0;
    int cnt = 0;
    U64 x64, bbb;
    U64 bb, att, t;

    f = CTRL_WR1;
    i = WR;
    bb = P->piece [i];

    while (bb)
    {
        k = j; //   

        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        //   
        val += pop_count (t & J->ofiles[1]) * ROOK_ON_SEMI;
        val += pop_count (t & J->ofiles[1] & J->ofiles[0]) * ROOK_ON_OPENED;

        //  7 
        if (t & rank_7 && (P->piece[BP] & rank_7 || P->piece[BK] & rank_8)) val += ROOK_ON_7TH;

        att = r_att (J->occ ^ J->rq[1], j);

        cnt ++;

        #ifdef USE_FAST_XRAYS
        val += xray (i, j); // 
        #endif

        //   
        #ifdef SOFT_CONTROL
        soft_control (f, att);
        #endif

        f <<= 1; //  

        // 
        val += r_trop [J->king_sq[0]][j];

        //    
        bbb = att & J->not_white & ~J->pawn_att[0];
        if (bbb & up_mask [j] & J->passers[1]) val += TARRASCH_RULE;

        if ((bbb & r_mobility[j]) != r_mobility[j]) val -= IMMOBILITY (R_MOB);

        //val += RMOB_F (pop_count (bbb & (U ^ dn_mask [j]))); // <-> 
        //val += RMOB_B (pop_count (bbb & dn_mask (j)));

        bb ^= t;
    };

    // 
    if (cnt > 1 && on_line[k][j])
    {
        bbb = J->occ & link_att[k][j];
        val += LINKED_ROOKS * max(0, 4 - pop_count (bbb));
    };

    return val;
};

inline int eval_b_rooks ()
{
    int i, j, k, f;
    int val = 0;
    int cnt = 0;
    U64 x64, bbb;
    U64 bb, att, t;

    f = CTRL_BR1;
    i = BR;
    bb = P->piece [i];

    while (bb)
    {
        k = j; //   

        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        //   
        val += pop_count_few (t & J->ofiles[0]) * ROOK_ON_SEMI;
        val += pop_count_few (t & J->ofiles[0] & J->ofiles[1]) * ROOK_ON_OPENED;

        //  2 
        if (t & rank_2 && (P->piece[WP] & rank_2 || P->piece[WK] & rank_1)) val += ROOK_ON_7TH;

        att = r_att (J->occ ^ J->rq[0], j);

        cnt ++;

        #ifdef USE_FAST_XRAYS
        val += xray (i, j); // 
        #endif

        //   
        #ifdef SOFT_CONTROL
        soft_control (f, att);
        #endif

        f <<= 1; //  

        // 
        val += r_trop [J->king_sq[1]][j];

        //    
        bbb = att & J->not_black & ~J->pawn_att[1];
        if (bbb & dn_mask [j] & J->passers[0]) val += TARRASCH_RULE;

        if ((bbb & r_mobility[j]) != r_mobility[j]) val -= IMMOBILITY (R_MOB);

        //val += RMOB_F (pop_count (bbb & (U ^ up_mask (j))));  // <-> 
        //val += RMOB_B (pop_count (bbb & up_mask (j)));

        bb ^= t;
    };

    // 
    if (cnt > 1 && on_line[k][j])
    {
        bbb = J->occ & link_att[k][j];
        val += LINKED_ROOKS * max(0, 4 - pop_count (bbb));
    };

    return val;
};

inline int eval_w_queens ()
{
    int i, j;
    int val = 0;
    int cnt = 0;
    U64 bb, t, att;
    U64 bbb;

    i = WQ;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        //  
        att = q_att (J->occ ^ (J->rq[1] | J->bq[1]), j);

        //cnt ++;

        #ifdef USE_FAST_XRAYS
        if (J->king_stage[1] > 4) val += xray (i, j); // 
        #endif

        //   
        #ifdef SOFT_CONTROL
        soft_control (CTRL_WQ, att);
        #endif

        // 
        val += q_trop [J->king_sq[0]][j];

        // 
        //bbb = att & J->not_white & ~J->pawn_att[0];
        //val += QMOB_F (pop_count (bbb & (U ^ dn_mask (j))));  // <-> 
        //val += QMOB_B (pop_count (bbb & dn_mask (j)));

        bb ^= t;
    };

    return val;
};

inline int eval_b_queens ()
{
    int i, j;
    int val = 0;
    int cnt = 0;
    U64 t;
    U64 bb, att;

    i = BQ;
    bb = P->piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        val += pst [i][j];

        //  
        att = q_att (J->occ ^ (J->rq[0] | J->bq[0]), j);

        cnt ++;

        #ifdef USE_FAST_XRAYS
        if (J->king_stage[0] > 4) val += xray (i, j); // 
        #endif

        //   
        #ifdef SOFT_CONTROL
        soft_control (CTRL_BQ, att);
        #endif

        // 
        val += q_trop [J->king_sq[1]][j];

        // 
        //bbb = att & J->not_black & ~J->pawn_att[1];
        //val += QMOB_F (pop_count (bbb & (U ^ up_mask (j))));  // <-> 
        //val += QMOB_B (pop_count (bbb & up_mask (j)));

        bb ^= t;
    };

    return val;
};

int eval_kqkp (int col)
{

};

inline int eval_w_tactics ()
{
    int k, val = 0;
    U64 att, bb, t;

    //   //////////////////////////////

    k = J->king_sq[1];

    //   

    //  *-*
    //  ---
    //  *-*

    att = J->king_safety[1] & (wpawn_att[k] | bpawn_att[k]);
    bb = att & J->bq[0];
    for (; bb; bb ^= t)
    {
        t = LSB (bb);
        val += CONTACT_CHECK;
    };

    //   

    //  -*-
    //  *-*
    //  -*-

    att ^= J->king_safety[1];
    bb = att & J->rq[0];
    for (; bb; bb ^= t)
    {
        t = LSB (bb);
        val += CONTACT_CHECK;
    };

    return val;
};

inline int eval_b_tactics ()
{
    int k, val = 0;
    U64 att, bb, t;

    //   //////////////////////////////

    k = J->king_sq[0];

    //   

    //  *-*
    //  ---
    //  *-*

    att = J->king_safety[0] & (wpawn_att[k] | bpawn_att[k]);
    bb = att & J->bq[1];
    for (; bb; bb ^= t)
    {
        t = LSB (bb);
        val += CONTACT_CHECK;
    };

    //   

    //  -*-
    //  *-*
    //  -*-

    att ^= J->king_safety[0];
    bb = att & J->rq[1];
    for (; bb; bb ^= t)
    {
        t = LSB (bb);
        val += CONTACT_CHECK;
    };

    return val;
};



inline void eval_precalc ()
{
    U64 bb;

    J->king_sq[1] = bitscan (P->piece [WK]);
	J->king_sq[0] = bitscan (P->piece [BK]);

	J->occ = P->occupied [0] | P->occupied [1];
	J->empty = ~J->occ;

	J->not_black = ~P->occupied [0];
	J->not_white = ~P->occupied [1];

	J->king_safety[1] = king_att [J->king_sq[1]];
	J->king_safety[0] = king_att [J->king_sq[0]];

	//  
	J->pawn_att[0]  = (P->piece[BP] & ~file_h) >> 7;
	J->pawn_att[0] |= (P->piece[BP] & ~file_a) >> 9;

	J->pawn_att[1]  = (P->piece[WP] & ~file_h) << 9;
	J->pawn_att[1] |= (P->piece[WP] & ~file_a) << 7;

    //        ? ( )
    J->q_is[1] = P->piece [WQ] ? 1 : 0;
    J->q_is[0] = P->piece [BQ] ? 1 : 0;

    // 
    J->mob[1] = J->mob[0] = 0;

    //    
    J->rq[1] = J->bq[1] = P->piece[WQ];
    J->rq[1] |= P->piece[WR];
    J->bq[1] |= P->piece[WB];

    J->rq[0] = J->bq[0] = P->piece[BQ];
    J->rq[0] |= P->piece[BR];
    J->bq[0] |= P->piece[BB];

    //   
    J->att_def = E;
    if (J->stage[0] <= STAGE_EG) J->att_def |= J->king_safety[1];
    if (J->stage[1] <= STAGE_EG) J->att_def |= J->king_safety[0];
    if (J->stage[0] <= STAGE_EG) if (J->stage[1] <= STAGE_EG) J->att_def |= CENTER;

    J->no_atts = U;
};

inline void soft_control (int id, const U64 & att)
{
    int j;
    U64 bb, t;

    //  : (     )

    //  hi
    //   15     14     13     12   |  11     10      9      8
    //  King   Queen  Rook   Rook  |      Total piece count

    //  lo
    //    7      6      5      4   |   3      2      1      0
    //  Bishop Knight Knight Pawn  |      Total piece count

    for (bb = att & J->att_def; bb; bb ^= t)
    {
        t = LSB (bb);
        j = bitscan (t);

        if (t & J->no_atts)
        {
            J->no_atts ^= t;
            J->atts [j] = 0;
        };

        J->atts [j] += (id & 0xFFFF) ? 129 : (129 << 16); //   1  2 
        J->atts [j] |= id;                               //    
    };
};

int evaluate (board * B, int alpha, int beta)
{
    int i, mat_score = 0, score = 0, type = 0;
    int cnt, val, mat_value;
    const int cut_off = w_n;
    const int stage_weights [14] = {0, 0, 1, 1, 1, 1, 3, 3, 6, 6, 0, 0,};
    U64 bb, x64;

    //return 0;

    // 1. 
    // 2.   PST ()
    // 3.  (     ,   )
    // 4.  
    // 5. 
    // 6. 

    //   <<   >>

    // 1.   (      )

    if (!(B->mat_key & UNUSIAL_MAT))
    {
        mat_t * mat_entry;
        mat_entry = mat_table + B->mat_key;
        mat_score = mat_entry->score;

        // 2. ,     (, KPK)

        type = mat_entry->type;

        J->stage[0] = mat_entry->stage[0];
        J->stage[1] = mat_entry->stage[1];
    }
    else
    {
        J->stage[0] = J->stage[1] = 0;
        for (i = WP; i < WK; i += 2)
        {
            cnt = pop_count (P->piece[i]);
            J->stage[1] += cnt * stage_weights [i];
            mat_score += cnt * material[i];
        };
        for (i = BP; i < BK; i += 2)
        {
            cnt = pop_count (P->piece[i]);
            J->stage[0] += cnt * stage_weights [i];
            mat_score -= cnt * material[i];
        };

        J->stage[0] = min (16, J->stage[0]);
        J->stage[1] = min (16, J->stage[1]);
    };

    // 2.1.  

    #ifdef LAZY_EVAL
    val = P->wtm ? mat_score : -mat_score;

    if (val + cut_off < alpha
    ||  val - cut_off > beta)
    {
        return exc_draw (val);
    };
    #endif

    //printf ("key: %i  score: %i  type: %i\n", B->mat_key, score, type);

    // 2.2.   

    eval_precalc ();

    // 3.  

    #ifdef PAWN_HASH
    pentry * p = pent_get (B);
    if (p == NULL)
    {
        val = eval_w_pawns () - eval_b_pawns ();
        pent_update (val, J, B);
        score += val;
    }
    else
    {
        score += p->score;

        J->ofiles[0]  = expand [p->ofiles[0]];
        J->ofiles[1]  = expand [p->ofiles[1]];
        J->targets[0] = p->targets[0];
        J->targets[1] = p->targets[1];
    };
    #else
    score += eval_w_pawns () - eval_b_pawns ();
    #endif

    #ifdef SOFT_CONTROL
    J->att_def |= J->targets[0] | J->targets[1];
    #endif

    score += (J->q_is[0]) ? J->shield[1] : 0;
    score -= (J->q_is[1]) ? J->shield[0] : 0;

    // 4. 

    score += eval_w_passers () - eval_b_passers ();

    #ifdef SOFT_CONTROL
    // 4.1.     
    soft_control (CTRL_BP, J->pawn_att[0]);
    soft_control (CTRL_WP, J->pawn_att[1]);
    #endif

    // 5.    

    score += eval_w_knights () - eval_b_knights ();
    score += eval_w_bishops () - eval_b_bishops ();
    score += eval_w_rooks   () - eval_b_rooks   ();

    score += calc_w_king_stage (B) - calc_b_king_stage (B);

    if (J->king_stage[1] > 4) score += eval_w_queens ();
    if (J->king_stage[0] > 4) score -= eval_b_queens ();

    /*
    if (abs(score) > MATE)
    {
        print_board (B);
        printf ("\n score: %d", score);
    };
    */

    #ifdef SOFT_CONTROL
    // 5.1 Soft Center Control
    U64 t;
    int j;

    for (U64 bb = CENTER & ~J->no_atts; bb; bb ^= t)
    {
        t = LSB (bb);
        j = bitscan (t);

        score += val_att_weak ( J->atts[j] );
    };
    #endif


    // 6.  

    score += eval_w_king (B) - eval_b_king (B);

    // 7.  

    score += eval_w_tactics () - eval_b_tactics ();

    // 8.



    // 9.   (scaling)



    //  
    score += TEMPO;

    score = mat_score + LINT (score);

    // 
    if (type == EVAL_BISHOPS)
    {
        if (P->piece[WB] & BLACK_COLOR)
        {
            if (P->piece[BB] & WHITE_COLOR) score /= 2;
        }
        else
        {
            if (P->piece[BB] & BLACK_COLOR) score /= 2;
        };
    };

    #ifdef DEBUG_EVAL
    debug_eval ();
    #endif

    //     
    score = exc_draw (score);

	return P->wtm ? score : -score;
};

void debug_eval ()
{

};









