#include "main.h"

//   
#define s_hash       0
#define s_gen_att    1
#define s_attacks    2
#define s_bad_cap    3
#define s_killer1    4
#define s_killer2    5
#define s_gen_quiet  6
#define s_quiet      7

int get_next_move (board * B)
{
    int i, mv, t1, t2;
    int last_move_to;
    hash_t * h;

    switch (B->stage)
    {
        case s_hash: //     ,  

            B->stage = s_gen_att;
            if (B->hmove) if (correct_move (B->hmove, B)) return B->hmove;

        case s_gen_att:

            B->stage = s_attacks;
            generate_attacks (B);
            order_attacks (B);
            B->curr = 0;

        case s_attacks:

            if (B->curr < B->size) return B->moves[B->curr ++];

        case s_killer1: //       

            B->stage = s_killer2;
            if (B->killer1) if (correct_move(B->killer1, B)) return B->killer1;

        case s_killer2:

            B->stage = s_gen_quiet;
            if (B->killer2) if (correct_move(B->killer2, B)) return B->killer2;

        case s_gen_quiet:

            B->stage = s_quiet;
            check_detection (B);
            generate_quiet (B);
            order_moves (B);
            B->curr = 0;

        case s_quiet:;

            if (B->curr < B->size) return B->moves[B->curr ++];

        case s_bad_cap:;
        default: break;
    };

    return 0;
};

int get_next_move_qs (board * B)
{
    int i, mv;
    int last_move_to;
    hash_t * h;

    switch (B->stage)
    {
        case s_hash: //   ()

            B->stage = s_gen_att;
            if (B->hmove) if (correct_move (B->hmove, B)) return B->hmove;

        case s_gen_att:

            B->stage = s_attacks;
            generate_attacks (B);
            order_attacks (B);
            B->curr = 0;

        case s_attacks:

            if (B->curr < B->size) return B->moves[B->curr ++];

        default: break;
    };

    return 0;
};

inline int correct_move (int mv, board * B)
{
    int _from, _to;
    int _piece, _flags;
    U64 occ = P->occupied[0] | P->occupied[1];
    const int slider [12] = {1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0}; //    ( )

    // : PIECE|FROM|TO|FLAGS

    if ((mv & 0x0F3F3FFF) != mv) return 0; //   

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;

    if (B->check_is) //   
    {
        build_mask (B);
        if (!(B->msk_bb & (I << _to))) //     
        {
            if (_piece < BK) //       
            return 0;       //   
        };
    };

    //        ?
    if ( !( P->occupied[P->wtm] & (I << _from) ) ) return 0;
    if ( P->squares[_from] != _piece ) return 0;

    //  ,       
    if (slider[_piece]) if ( occ & link_att[_from][_to] ) return 0;

    //  -  
    switch (_flags & f_mask)
    {
        case f_prom: //  //////////////////////////////////////////////////

            if (_piece > 1) return 0; //   
            if (P->wtm)              //  
            {
                if (hori(_from) != 6 || (_to - _from) != 8) return 0;
            }
            else
            {
                if (hori(_from) != 1 || (_from - _to) != 8) return 0;
            };

            //       
            if ( occ & (I << _to) ) return 0;

            return 1;

        break;

        case f_prom | f_capture: //    ///////////////////////////

            if (_piece > 1) return 0; //   
            if (P->wtm)              //  
            {
                if (hori(_from) != 6 || ((_to - _from) != 7 && (_to - _from) != 9)) return 0;
            }
            else
            {
                if (hori(_from) != 1 || ((_from - _to) != 7 && (_from - _to) != 9)) return 0;
            };

            //       
            if ( !( P->occupied[!P->wtm] & (I << _to) ) ) return 0;

            return 1;

        break;

        case f_capture: //  ////////////////////////////////////////////////////

            if ((_piece & 1) != P->wtm) return 0;
            if (_piece > WK) return 0;

            //       
            if ( !( P->occupied[!P->wtm] & (I << _to) ) ) return 0;

        break;

        case f_ep: //    //////////////////////////////////////////////

            if (_to != B->en_passant) return 0;
            if (_piece > 1) return 0; //   

        break;

        case f_castling: //  ////////////////////////////////////////////////

            if (B->check_is) return 0;

            if (_from > _to) // 
            {
                if (!(B->castling_rights & queen_cast [P->wtm])) return 0;

                //   ,     
                if (_piece & 1)
                {
                    if (occ & (_B1 | _C1 | _D1)) return 0;
                }
                else
                {
                    if (occ & (_B8 | _C8 | _D8)) return 0;
                };

                break;
            };

            // 

            if (!(B->castling_rights & king_cast [P->wtm])) return 0;

            //  ,     
            if (_piece & 1)
            {
                if (occ & (_F1 | _G1)) return 0;
            }
            else
            {
                if (occ & (_F8 | _G8)) return 0;
            };

            break;

        default: //   //////////////////////////////////////////////////////

            if ( occ & (I << _to) ) return 0;

        break;
    };

    return 1;
};

void order_attacks (board * B)
{
    int i, p;
    int val;
    int mv;
    int _from, _to;
    int _piece, _flags;
    int last_move_to;
    int values [256];

    //    ?
    last_move_to = (B != S->B_start) ? TO ((B-1)->cmove) : 100;

    for (i = 0; i < B->size; i ++)
    {
        mv     = B->moves [i];
        if (mv == B->hmove || mv == B->killer1 || mv == B->killer2) //    
        {
            B->moves[i] = B->moves[--B->size];
            i --;
            continue;
        };

        _flags = (mv & 0x000000FF);
        _to    = (mv & 0x0000FF00) >> 8;
        _from  = (mv & 0x00FF0000) >> 16;
        _piece = (mv & 0xFF000000) >> 24;

        // recapture //////////////////////////////

        if (_to == last_move_to)
        {
            values [i] = o_recapture - material [_piece];
            continue;
        };

        // promotions /////////////////////////////

        if (is_prom (_flags))
        {
            values [i] = o_prom + (_flags & (~f_mask));
            continue;
        };

        // captures ///////////////////////////////

        if (is_capture (_flags))
        {
            p = P->squares [_to];

            // MVV / LVA
            val = (material [p] << 5) - material [_piece];

            if      (val > 0) values [i] = o_good_cap + val;
            else if (val < 0) //    ?
            {
                val = see(mv);
                values [i] = (val > 0) ? o_good_cap + val : o_bad_cap + val;
            };

            continue;
        };

        // history ////////////////////////////////

        values [i] = history [_from][_to];

        // pst gain ///////////////////////////////
        p = _piece;
        if (p == WK)
        {
            if (!P->piece[BQ]) p += 2; //  
        }
        else if (p == BK)
        {
            if (!P->piece[WQ]) p += 2; //  
        };

        values [i] += LINT (pst [p][_to] - pst [p][_from]);
    };

    shell_sort ((int*)values, (int*)B->moves, B->size);
};

void order_moves (board * B)
{
    int i, p;
    int val;
    int mv;
    int _from, _to;
    int _piece, _flags;
    int values [256];

    for (i = 0; i < B->size; i ++)
    {
        mv     = B->moves[i];
        if (mv == B->hmove || mv == B->killer1 || mv == B->killer2) //    
        {
            B->moves[i] = B->moves[--B->size];
            i --;
            continue;
        };

        _flags = (mv & 0x000000FF);
        _to    = (mv & 0x0000FF00) >> 8;
        _from  = (mv & 0x00FF0000) >> 16;
        _piece = (mv & 0xFF000000) >> 24;

        /*
        //       
        if (_piece == 0)
        {
            //if (hori(_from) == 3) values [i] += o_pawn_4;
            if (hori(_from) == 2) values [i] += o_pawn_5;
            if (hori(_from) == 1) values [i] += o_pawn_6;
        };

        if (_piece == 1)
        {
            //if (hori(_from) == 4) values [i] += o_pawn_4;
            if (hori(_from) == 5) values [i] += o_pawn_5;
            if (hori(_from) == 6) values [i] += o_pawn_6;
        };
        */

        // evasions ///////////////////////////////

        if (B->check_is && _piece >= BK)
        {
            values [i] = o_evasion;
            continue;
        };

        /*
        // killers ////////////////////////////////

        if (mv == B->killer1)
        {
            values [i] = o_killer;
            continue;
        };

        if (mv == B->killer2)
        {
            values [i] = o_killer / 2;
            continue;
        };
        */

        // history ////////////////////////////////

        values [i] = history [_from][_to];

        // pst gain ///////////////////////////////
        p = _piece;
        if (p == WK)
        {
            if (!P->piece[BQ]) p += 2; //  
        }
        else if (p == BK)
        {
            if (!P->piece[WQ]) p += 2; //  
        };

        values [i] += LINT (pst [p][_to] - pst [p][_from]);
    };

    shell_sort ((int*)values, (int*)B->moves, B->size);
};

void order_moves_all (board * B)
{
    int i, p;
    int val;
    int mv;
    int _from, _to, _flags;
    int _piece;
    int last_move_to;

    int values [256];

    int hash_move = 0;

    //     ,  
    hash_t * h = hash_get (H, B);
    if (h != NULL/* && h->age == S->g_hash_age*/) hash_move = h->move;

    //    ?
    last_move_to = (B != S->B_start) ? TO ((B-1)->cmove) : 100;

    for (i = 0; i < B->size; i ++)
    {
        mv     = B->moves [i];
        if (mv == B->hmove || mv == B->killer1 || mv == B->killer2) //    
        {
            B->moves[i] = B->moves[--B->size];
            i --;
            continue;
        };

        _flags = (mv & 0x000000FF);
        _to    = (mv & 0x0000FF00) >> 8;
        _from  = (mv & 0x00FF0000) >> 16;
        _piece = (mv & 0xFF000000) >> 24;


        // evasions ///////////////////////////////

        if (B->check_is && _piece >= BK)
        {
            values [i] = o_evasion;
            continue;
        };

        // hash ///////////////////////////////////

        if (hash_move && mv == hash_move)
        {
            values [i] = o_hash;
            continue;
        };

        // recapture //////////////////////////////

        if (_to == last_move_to)
        {
            values [i] = o_recapture - material [_piece];
            continue;
        };

        // promotions /////////////////////////////

        if (is_prom (_flags))
        {
            values [i] = o_prom + (_flags & (~f_mask));
            continue;
        };

        // captures ///////////////////////////////

        if (is_capture (_flags))
        {
            p = P->squares [_to];

            // MVV / LVA
            val = (material [p] << 5) - material [_piece];

            if      (val > 0) values [i] = o_good_cap + val;
            else if (val < 0) //    ?
            {
                val = see(mv);
                values [i] = (val > 0) ? o_good_cap + val : o_bad_cap + val;
            };

            continue;
        };

        // killers ////////////////////////////////

        if (mv == B->killer1)
        {
            values [i] = o_killer;
            continue;
        };

        if (mv == B->killer2)
        {
            values [i] = o_killer / 2;
            continue;
        };

        // history ////////////////////////////////

        values [i] = history [_from][_to];

        // pst gain ///////////////////////////////
        p = _piece;
        if (p == WK)
        {
            if (!P->piece[BQ]) p += 2; //  
        }
        else if (p == BK)
        {
            if (!P->piece[WQ]) p += 2; //  
        };

        values [i] += LINT (pst [p][_to] - pst [p][_from]);
    };

    shell_sort ((int*)values, (int*)B->moves, B->size);
};

int do_move (int mv, int prom, board * B)
{
    int i, sz;
    int move;
    int mask; //    

	if (prom) mask = 0x00FFFF03 | f_prom; //     
	else      mask = 0x00FFFF00;         //     !

    //  
    generate (B);

    sz = B->size;

    for (i = 0; i < sz; i ++)
    {
        move = B->moves[i];

        //     
        if ((move & mask) == mv)
        {
            //   
            if (make_move (move, B, 1)) return 1;

            //  ,    -  
        };
    };

    return 0;
};

int find_masked_move (int mv, int mask, board * B)
{
    int i, sz;
    int move;

    //  
    check_detection (B);
    generate (B);

    sz = B->size;

    for (i = 0; i < sz; i ++)
    {
        move = B->moves[i];

        //     
        if ((move & mask) == (mv & mask))
        {
            //   ,    
            if (legality_test (move, B)) return i;

            //  ,   
        };
    };

    return -1; //   , 
};

inline int generate (board * B)
{
    int k_cast, q_cast;
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    int ep;
    U64 bb, p;
    U64 att, t, occ;
    U64 occ_own, occ_opp;
    U64 not_own;
    U64 cm_k, cm_q;      // ,  

    B->msk_bb = U;
    B->taken = no_p;
    B->size = 0;
    B->n_evasions = 0;

    occ_own = P->occupied [P->wtm];
    occ_opp = P->occupied [!P->wtm];

    not_own = ~occ_own;

    occ = occ_own | occ_opp;

    k_cast = king_cast [P->wtm]; //  
    q_cast = queen_cast [P->wtm];

    cm_k = (P->wtm) ? c_mov_K : c_mov_k; //    
    cm_q = (P->wtm) ? c_mov_Q : c_mov_q;

    //  (    )
    i = BK + P->wtm;

    bb = P->piece [i];
    j = bitscan (bb);

    for (att = king_att [j] & not_own; att; att ^= t)
    {
        t = LSB (att);
        k = bitscan (t);

        B->n_evasions ++;

        generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    }
    else
    {
        // ,   
        if ((B->castling_rights & k_cast)
        &&  (!(occ & cm_k)))
        {
            generate_moves (i, j, j + 2, f_castling, B);
        };

        if ((B->castling_rights & q_cast)
        &&  (!(occ & cm_q)))
        {
            generate_moves (i, j, j - 2, f_castling, B);
        };
    };

    B->msk_bb &= not_own; //   -     

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = q_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = r_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = b_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = knight_att [j] & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
        };
    };

    // 
    i -= 2;

    bb = P->piece [i];

    if (!P->wtm)
    {
        for (att = ((bb & ~file_h) >> 7) & occ_opp & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 7, k, f_capture, B);
            else        generate_proms (i, k + 7, k, f_capture, B, m);
        };

        for (att = ((bb & ~file_a) >> 9) & occ_opp & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 9, k, f_capture, B);
            else        generate_proms (i, k + 9, k, f_capture, B, m);
        };

        for (att = (bb >> 8) & ~occ & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 8, k, 0, B);
            else        generate_proms (i, k + 8, k, 0, B, m);
        };

        for (att = (bb >> 16) & (~occ >> 8) & ~occ & rank_5 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 16, k, f_none, B);
            else        generate_proms (i, k + 16, k, f_none, B, m);
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            for (att = wpawn_att [ep] & bb; att; att ^= t)
            {
                t = LSB (att);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);
            };
        };
    }
    else
    {
        for (att = ((bb & ~file_h) << 9) & occ_opp & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 9, k, f_capture, B);
            else        generate_proms (i, k - 9, k, f_capture, B, m);
        };

        for (att = ((bb & ~file_a) << 7) & occ_opp & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 7, k, f_capture, B);
            else        generate_proms (i, k - 7, k, f_capture, B, m);
        };

        for (att = (bb << 8) & ~occ & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 8, k, 0, B);
            else        generate_proms (i, k - 8, k, 0, B, m);
        };

        for (att = (bb << 16) & (~occ << 8) & ~occ & rank_4 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 16, k, f_none, B);
            else        generate_proms (i, k - 16, k, f_none, B, m);
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            for (att = bpawn_att [ep] & bb; att; att ^= t)
            {
                t = LSB (att);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);
            };
        };
    };

    return B->size;
};


int generate_attacks (board * B)
{
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    int ep;
    U64 bb, p;
    U64 att, t, occ;
    U64 occ_own, occ_opp;

    B->msk_bb = U;
    B->taken = no_p;
    B->size = 0;
    B->n_evasions = 0;

    occ_own = P->occupied [P->wtm];
    occ_opp = P->occupied [!P->wtm];

    occ = occ_own | occ_opp;

    //  (    )
    i = BK + P->wtm;

    bb = P->piece [i];
    j = bitscan (bb);

    for (att = king_att [j] & occ_opp; att; att ^= t)
    {
        t = LSB (att);
        k = bitscan (t);

        B->n_evasions ++;

        generate_moves (i, j, k, f_capture, B);
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    };

    B->msk_bb &= occ_opp; //   -     


    //   


    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = q_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = r_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = b_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = knight_att [j] & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);
        };
    };

    // 
    i -= 2;

    bb = P->piece [i];

    if (!P->wtm)
    {
        for (att = ((bb & ~file_h) >> 7) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 7, k, f_capture, B);
            else        generate_proms (i, k + 7, k, f_capture, B, m);
        };

        for (att = ((bb & ~file_a) >> 9) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 9, k, f_capture, B);
            else        generate_proms (i, k + 9, k, f_capture, B, m);
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            for (att = wpawn_att [ep] & bb; att; att ^= t)
            {
                t = LSB (att);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);
            };
        };
    }
    else
    {
        for (att = ((bb & ~file_h) << 9) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 9, k, f_capture, B);
            else        generate_proms (i, k - 9, k, f_capture, B, m);
        };

        for (att = ((bb & ~file_a) << 7) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 7, k, f_capture, B);
            else        generate_proms (i, k - 7, k, f_capture, B, m);
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            for (att = bpawn_att [ep] & bb; att; att ^= t)
            {
                t = LSB (att);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);
            };
        };
    };

    return B->size;
};

int generate_quiet (board * B)
{
    int k_cast, q_cast;
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    U64 bb, p;
    U64 att, t, occ;
    U64 occ_own, occ_opp;
    U64 empty;
    U64 cm_k, cm_q;      // ,  

    B->msk_bb = U;
    B->taken = no_p;
    B->size = 0;
    B->n_evasions = 0;

    occ_own = P->occupied [P->wtm];
    occ_opp = P->occupied [!P->wtm];

    occ = occ_own | occ_opp;
    empty = ~occ;

    k_cast = king_cast [P->wtm]; //  
    q_cast = queen_cast [P->wtm];

    cm_k = (P->wtm) ? c_mov_K : c_mov_k; //    
    cm_q = (P->wtm) ? c_mov_Q : c_mov_q;

    //  (    )
    i = BK + P->wtm;

    bb = P->piece [i];
    j = bitscan (bb);

    for (att = king_att [j] & empty; att; att ^= t)
    {
        t = LSB (att);
        k = bitscan (t);

        B->n_evasions ++;

        generate_moves (i, j, k, 0, B);
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    }
    else
    {
        // ,   
        if ((B->castling_rights & k_cast)
        &&  (!(occ & cm_k)))
        {
            generate_moves (i, j, j + 2, f_castling, B);
        };

        if ((B->castling_rights & q_cast)
        &&  (!(occ & cm_q)))
        {
            generate_moves (i, j, j - 2, f_castling, B);
        };
    };

    B->msk_bb &= empty; //   -  ,   

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = q_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = r_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = b_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = knight_att [j] & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    bb = P->piece [i];

    if (!P->wtm)
    {
        for (att = (bb >> 8) & empty & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 8, k, 0, B);
            else        generate_proms (i, k + 8, k, 0, B, m);
        };

        for (att = (bb >> 16) & (empty >> 8) & empty & rank_5 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 16, k, f_none, B);
            else        generate_proms (i, k + 16, k, f_none, B, m);
        };
    }
    else
    {
        for (att = (bb << 8) & empty & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 8, k, 0, B);
            else        generate_proms (i, k - 8, k, 0, B, m);
        };

        for (att = (bb << 16) & (empty << 8) & empty & rank_4 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 16, k, f_none, B);
            else        generate_proms (i, k - 16, k, f_none, B, m);
        };
    };

    return B->size;
};

int generate_checks (board * B) //  !
{
    int k_cast, q_cast;
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    int ki, pie;        //  ,   
    int step = 0;      //      -   
    U64 bb, p, blc, xry;
    U64 kng, att, t, occ;
    U64 occ_own, occ_opp;
    U64 not_own;
    U64 empty;
    U64 cm_k, cm_q;      // ,  
    U64 rq, bq;
    U64 mask;
    U64 looked;         // ,  
    U64 b_kng, r_kng;  //      

    B->msk_bb = U;
    B->taken = no_p;
    B->size = 0;
    B->n_evasions = 0;

    occ_own = P->occupied [P->wtm];
    occ_opp = P->occupied [!P->wtm];

    not_own = ~occ_own;

    occ = occ_own | occ_opp;
    empty = ~occ;

    rq = bq = P->piece [BQ + P->wtm];
    rq     |= P->piece [BR + P->wtm];
    bq     |= P->piece [BB + P->wtm];

    k_cast = king_cast [P->wtm]; //  
    q_cast = queen_cast [P->wtm];

    cm_k = (P->wtm) ? c_mov_K : c_mov_k; //    
    cm_q = (P->wtm) ? c_mov_Q : c_mov_q;


    //   ///////////////////////////////////////////////////////////////

    //       
    bb = P->piece [BK + !P->wtm];
    ki = bitscan (bb);

    b_kng = b_att (occ, ki);
    r_kng = r_att (occ, ki);

    for (step = 0; step < 2; step ++)
    {
        kng = step ? b_kng : r_kng;  //    
        blc = kng & occ_own;        //  

        xry = step
              ? (b_att (occ ^ blc, ki) & bq)
              : (r_att (occ ^ blc, ki) & rq); //  ,  

        for (; xry; xry ^= p)
        {
            p = LSB (xry); //   
            j = bitscan (p);
            mask = link_att [j][ki];

            t = mask & blc & (step ? bq : rq);
            j = bitscan (t); //   
            i = P->squares [j];

            /*
            switch (to_black(i)) //       ,  ?
            {
                case BP: att  = (bb >> 8) | (bb >> 16) & (empty >> 8) & rank_5) & empty;
                         att |=
                case BN: att  = knight_att [j]; break;
                case BB: att  = b_att (occ, j); break;
                case BR: att  = r_att (occ, j); break;
                case BQ: att  = q_att (occ, j); break;
                case BK: att  = king_att [j]; break;
            };
            */

            att &= ~mask & B->msk_bb; //     

            for (; att; att ^= t)
            {
                t = LSB (att);
                k = bitscan (t);

                generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);
            };

            //    , , .       

        };
    };

    //   ////////////////////////////////////////////////////////////////

    bb = P->piece [BN + P->wtm];



    //  (    )
    i = BK + P->wtm;

    bb = P->piece [i];
    j = bitscan (bb);

    for (att = king_att [j] & empty; att; att ^= t)
    {
        t = LSB (att);
        k = bitscan (t);

        B->n_evasions ++;

        generate_moves (i, j, k, 0, B);
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    }
    else
    {
        // ,   
        if ((B->castling_rights & k_cast)
        &&  (!(occ & cm_k)))
        {
            generate_moves (i, j, j + 2, f_castling, B);
        };

        if ((B->castling_rights & q_cast)
        &&  (!(occ & cm_q)))
        {
            generate_moves (i, j, j - 2, f_castling, B);
        };
    };

    B->msk_bb &= empty; //   -  ,   

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = q_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = r_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = b_att (occ, j) & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    for (bb = P->piece [i]; bb; bb ^= p)
    {
        p = LSB (bb);
        j = bitscan (p);

        for (att = knight_att [j] & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, 0, B);
        };
    };

    // 
    i -= 2;

    bb = P->piece [i];

    if (!P->wtm)
    {
        for (att = (bb >> 8) & empty & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 8, k, 0, B);
            else        generate_proms (i, k + 8, k, 0, B, m);
        };

        for (att = (bb >> 16) & (empty >> 8) & empty & rank_5 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 16, k, f_none, B);
            else        generate_proms (i, k + 16, k, f_none, B, m);
        };
    }
    else
    {
        for (att = (bb << 8) & empty & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 8, k, 0, B);
            else        generate_proms (i, k - 8, k, 0, B, m);
        };

        for (att = (bb << 16) & (empty << 8) & empty & rank_4 & B->msk_bb; att; att ^= t)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 16, k, f_none, B);
            else        generate_proms (i, k - 16, k, f_none, B, m);
        };
    };

    return B->size;
};

int generate_legal (board * B) // Some slow. Use carefully
{
    int i, move, sz;
    int legal = 0;
    int values [256];

    check_detection (B);

    sz = generate (B);

    for (i = 0; i < sz; i ++)
    {
        move = B->moves[i];
        if (legality_test (move, B))
        {
            legal ++;
            values [i] = 1;
        }
        else values [i] = 0;
    };

    shell_sort ((int*)values, (int*)B->moves, sz);

    B->size = legal;

    order_moves_all (B);

    return legal;
};

int legality_test (int mv, board * B) //  ep ?
{
    int _piece;
    int _from, _to;
    int _toep, _flags;
    int p;
    int king_sq;
    U64 occ, bb;
    U64 rq, bq;

    //print_move (mv);

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;

    //        
    occ = P->occupied[0] | P->occupied[1];
    occ ^= I << _from;

    // 
    if (is_castling(mv) || _flags == f_castling)
    {
        //  !!!
        if (is_attacked (occ,  _to,              !P->wtm)) return 0;
        if (is_attacked (occ, (_from + _to) / 2, !P->wtm)) return 0;
        return 1;
    };

    //      ( )
    if ((_piece >> 1) == KING_ID)
    {
        if (is_attacked (occ, _to, !P->wtm)) return 0;
        return 1;
    };

    rq = bq = P->piece[BQ + !P->wtm];
    rq |= P->piece[BR + !P->wtm];
    bq |= P->piece[BB + !P->wtm];

    king_sq = bitscan (P->piece[BK + P->wtm]);

    //    
    switch (_flags & f_mask)
    {
        case f_capture:

            p = P->squares [_to];
            if (is_linr (p)) rq ^= I << _to;
            if (is_diag (p)) bq ^= I << _to;
            break;

        case f_ep:

            // ,   
            _toep = (_to & 7) + (_from & 0xF8);
            occ ^= I << _toep;
            occ ^= I << _to;
            break;

        case f_prom:
        default:

            occ ^= I << _to;
            break;
    };

    //     ?
    if (vert(king_sq) == vert(_from)
    ||  hori(king_sq) == hori(_from))
    {
        // 
        bb = r_att (occ, king_sq) & rq;
        if (bb) return 0;
    }
    else //     ??
    {
        // 
        bb = b_att (occ, king_sq) & bq;
        if (bb) return 0;
    };

    return 1;
};

int make_move (int mv, board * B, int self)
{
    int _piece;
    int piece_to, t, p;
    int _from, _to;
    int _toep, _flags;
    U64 a1, a2;
    board * N;

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;


    N = self ? B : (B + 1); // ,  

    N->mat_key = B->mat_key;
    N->phash = B->phash;

    N->hash_mat = B->hash_mat ^ hash_key_wtm [0];

    N->en_passant = 0;

    B->taken = no_p;

    //     
    N->castling_rights = B->castling_rights
                       & un_castling [_from]
                       & un_castling [_to];

    switch (_flags & f_mask)
    {
        case f_prom: //  //////////////////////////////////////////////////

        t = p = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += P->wtm; //  

        a1 = (I << _from);
        a2 = (I << _to);

        P->piece [_piece]    ^= a1;
        P->piece [t]         ^= a2;
        P->occupied [P->wtm] ^= a1 | a2;
        P->squares [_to] = t;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [t][_to];

        N->phash    ^= pawn_key [_piece][_from];

        if (!(N->mat_key & UNUSIAL_MAT))
        {
            if ( mat_table [N->mat_key].overload & (1 << (p + ((P->wtm) << 2))) ) N->mat_key |= UNUSIAL_MAT;
            else
            {
                N->mat_key += mat_keys [t];
                N->mat_key -= mat_keys [_piece];
            };
        };

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_prom | f_capture: //    ///////////////////////////////////////

        //   
        piece_to = P->squares [_to];

        B->taken = piece_to;

        a1 = (I << _to);

        P->piece [piece_to]    ^= a1;
        P->occupied [!P->wtm]  ^= a1;

        t = p = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += P->wtm; //  

        a2 = (I << _from);

        P->piece [_piece]      ^= a2;
        P->piece [t]           ^= a1;
        P->occupied [P->wtm]   ^= a1 | a2;
        P->squares [_to] = t;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [piece_to][_to]
                    ^  hash_key [t][_to];

        N->phash    ^= pawn_key [_piece][_from];

        //mat [P->wtm] += material [t] - material [_piece];
        //mat [!P->wtm] -= material [piece_to];

        if (!(N->mat_key & UNUSIAL_MAT))
        {
            if ( mat_table [N->mat_key].overload & (1 << (p + ((P->wtm) << 2))) ) N->mat_key |= UNUSIAL_MAT;
            else
            {
                N->mat_key += mat_keys [t];
                N->mat_key -= mat_keys [_piece];
                N->mat_key -= mat_keys [piece_to];
            };
        };

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_capture: //  ///////////////////////////////////////////////////////

        //   
        //if (!(P->occupied[!P->wtm] & (I << _to))) uci_send ("\n WRONG CAPTURE!");
        piece_to = P->squares [_to];

        B->taken = piece_to; //   

        a1 = (I << _to);
        a2 = (I << _from) | a1;

        P->piece [_piece]     ^= a2;
        P->piece [piece_to]   ^= a1;
        P->occupied [P->wtm]  ^= a2;
        P->occupied [!P->wtm] ^= a1;
        P->squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [piece_to][_to];

        if (_piece   < 2) N->phash ^= pawn_key [_piece][_from];
        if (piece_to < 2) N->phash ^= pawn_key [_piece][_to];

        //mat [!P->wtm] -= material [piece_to];

        if (!(N->mat_key & UNUSIAL_MAT))
        {
            N->mat_key -= mat_keys [piece_to];
        };

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_ep: //    ////////////////////////////////////////////

        // ,    
        _toep = (_to & 7) + (_from & 0xF8);

        t = _piece ^ 1;

        B->taken = t; //   

        a1 = (I << _from) | (I << _to);
        a2 = (I << _toep);

        P->piece [_piece]     ^= a1;
        P->piece [t]          ^= a2;
        P->occupied [P->wtm]  ^= a1;
        P->occupied [!P->wtm] ^= a2;
        P->squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [t][_toep];

        N->phash    ^= pawn_key [_piece][_from]
                    ^  pawn_key [_piece][_to]
                    ^  pawn_key [t][_toep];

        //mat [!P->wtm] -= material [t];

        if (!(N->mat_key & UNUSIAL_MAT))
        {
            N->mat_key -= mat_keys [t];
        };

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_castling: //  ////////////////////////////////////////////////////

        if (_from > _to) // 
        {
            a1 = (I << _from) | (I << _to);
            a2 = (I << (_to - 2)) | (I << (_to + 1));

            P->piece [_piece]        ^= a1;
            P->piece [BR + P->wtm]   ^= a2;
            P->occupied [P->wtm]     ^= a1 | a2;
            P->squares [_to] = _piece;
            P->squares [_to + 1] = BR + P->wtm;


            N->hash_mat ^= hash_key [_piece][_from]
                        ^  hash_key [_piece][_to]
                        ^  hash_key [BR + P->wtm][_to - 2]
                        ^  hash_key [BR + P->wtm][_to + 1];

            //S->irreversible_ply = S->count_moves; //     ?

            break;
        };

        // 

        a1 = (I << _from) | (I << _to);
        a2 = (I << (_to + 1)) | (I << (_to - 1));

        P->piece [_piece]        ^= a1;
        P->piece [BR + P->wtm]   ^= a2;
        P->occupied [P->wtm]     ^= a1 | a2;
        P->squares [_to] = _piece;
        P->squares [_to - 1] = BR + P->wtm;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [BR + P->wtm][_to + 1]
                    ^  hash_key [BR + P->wtm][_to - 1];

        //S->irreversible_ply = S->count_moves; //     ?
        S->fifty ++;

        break;

        default: //   //////////////////////////////////////////////////

        a1 = (I << _from) | (I << _to);

        P->piece [_piece]     ^= a1;
        P->occupied [P->wtm]  ^= a1;
        P->squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to];

        //     ,     
        if (_piece < 2)
        {
            //       ////////////////////
            if (absu (_from, _to) == 16) N->en_passant = (_from + _to) >> 1;

            N->phash ^= pawn_key [_piece][_from]
                     ^  pawn_key [_piece][_to];

            S->irreversible_ply = S->count_moves;
            S->fifty = 0;
        }
        else S->fifty ++;

        break;
    };

    N->hash  =  N->hash_mat
             ^  hash_key_ep   [N->en_passant]
             ^  hash_key_cast [N->castling_rights];

    P->wtm ^= 1;

    S->count_moves ++;

    //         (unmake_move)
    R[S->count_moves].irreversible_last = S->irreversible_ply;

    //  -    
    R[S->count_moves].key = N->hash;

    S->ply ++;

    //test_occ_pie_squ (B);

    return mv;
};

int test_occ_pie_squ (board * B) //  ,  piece - occupied
{
    int i, j;
    U64 bb, t;

    for (i = 0; i < 12; i ++)
    {
        bb = P->piece[i];
        if ((bb & P->occupied[i & 1]) != bb) //    
        {
            uci_send ("\n ERR: piece[%i] - occupied[%i]", i, i & 1);
            print_board (B);
            print_this_att (bb);
            print_this_att (P->occupied[i & 1]);
        };

        for (; bb; bb ^= t)
        {
            t = LSB (bb);
            j = bitscan (t);

            if (P->squares[j] != i)
            {
                uci_send ("\n ERR: piece[%i] - squares[%i]", i, j);
                print_board (B);
                print_this_att (t);
                uci_send ("\n is squares %i\n\n", P->squares[j]);
            };
        };
    };
};

void unmake_move (int mv, board * B)
{
    int _piece;
    int piece_to, t;
    int _from, _to;
    int _toep, _flags;
    U64 a1, a2;

    S->ply --;

    P->wtm ^= 1;

    S->count_moves --;

    //      50      
    S->fifty = S->irreversible_ply - R[S->count_moves].irreversible_last - 1;
    S->irreversible_ply = R[S->count_moves].irreversible_last;

    //     
    R[S->count_moves + 1].key = E;
    R[S->count_moves + 1].irreversible_last = 0;

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;


    switch (_flags & f_mask)
    {
        case f_prom: //  //////////////////////////////////////////////////

        t = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += P->wtm; //  

        a1 = (I << _from);
        a2 = (I << _to);

        P->piece [_piece]     ^= a1;
        P->piece [t]          ^= a2;
        P->occupied [P->wtm]  ^= a1 | a2;
        P->squares [_from] = _piece;

        //mat [P->wtm] -= material [t] - material [_piece];
        break;

        case f_prom | f_capture: //    /////////////////////////////

        piece_to = B->taken;

        a1 = (I << _to);

        P->piece [piece_to] ^= a1;

        P->occupied [!P->wtm] ^= a1;

        t = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += P->wtm; //  

        a2 = (I << _from);

        P->piece [_piece]     ^= a2;
        P->piece [t]          ^= a1;
        P->occupied [P->wtm]  ^= a1 | a2;
        P->squares [_from] = _piece;
        P->squares [_to] = piece_to;

        //mat [P->wtm] -= material [t] - material [_piece];
        //mat [!P->wtm] += material [piece_to];
        break;

        case f_capture: //  ///////////////////////////////////////////////////////

        piece_to = B->taken;

        a1 = (I << _to);
        a2 = (I << _from) | a1;

        P->piece [_piece]     ^= a2;
        P->piece [piece_to]   ^= a1;
        P->occupied [P->wtm]  ^= a2;
        P->occupied [!P->wtm] ^= a1;
        P->squares [_from] = _piece;
        P->squares [_to] = piece_to;

        //mat [!P->wtm] += material [piece_to];
        break;

        case f_ep: //    ////////////////////////////////////////////

        // ,    
        _toep = (_to & 7) + _from - (_from & 7);

        t = _piece ^ 1;

        a1 = (I << _from) | (I << _to);
        a2 = (I << _toep);

        P->piece [_piece]     ^= a1;
        P->piece [t]          ^= a2;
        P->occupied [P->wtm]  ^= a1;
        P->occupied [!P->wtm] ^= a2;
        P->squares [_from] = _piece;
        P->squares [_toep] = t;

        //mat [!P->wtm] += material [t];
        break;

        case f_castling: //  ////////////////////////////////////////////////////

        if (_from > _to) // 
        {
            a1 = (I << _from) | (I << _to);
            a2 = (I << (_to - 2)) | (I << (_to + 1));

            P->piece [_piece]       ^= a1;
            P->piece [BR + P->wtm]  ^= a2;
            P->occupied [P->wtm]    ^= a1 | a2;
            P->squares [_from] = _piece;
            P->squares [_to - 2] = BR + P->wtm;

            break;
        };

        // 

        a1 = (I << _from) | (I << _to);
        a2 = (I << (_to + 1)) | (I << (_to - 1));

        P->piece [_piece]       ^= a1;
        P->piece [BR + P->wtm]  ^= a2;
        P->occupied [P->wtm]    ^= a1 | a2;
        P->squares [_from] = _piece;
        P->squares [_to + 1] = BR + P->wtm;

        break;

        default: //   //////////////////////////////////////////////////

        a1 = (I << _from) | (I << _to);

        P->piece [_piece]    ^= a1;
        P->occupied [P->wtm] ^= a1;
        P->squares [_from] = _piece;

        break;
    };
};

void make_null  (board * B)
{
    board * N = B + 1;

    B->cmove = 0; //   - 

    N->castling_rights = B->castling_rights;

    N->mat_key = B->mat_key;
    N->phash = B->phash;

    N->hash_mat = B->hash_mat ^ hash_key_wtm [0];

    N->en_passant = 0;
    N->hash  =  B->hash
             ^  hash_key_ep   [B->en_passant] /////////////////////// (!)
             ^  hash_key_wtm  [0];

    P->wtm ^= 1;
    S->ply ++;

    S->fifty ++;
    S->count_moves ++;

    //         (unmake_move)
    R[S->count_moves].irreversible_last = S->irreversible_ply;

    //  -    
    R[S->count_moves].key = N->hash;
};

void unmake_null  ()
{
    P->wtm ^= 1;
    S->ply --;

    S->count_moves --;

    //      50      
    S->fifty = S->irreversible_ply - R[S->count_moves].irreversible_last - 1;
    S->irreversible_ply = R[S->count_moves].irreversible_last;

    //     
    R[S->count_moves + 1].key = E;
    R[S->count_moves + 1].irreversible_last = 0;
};

int update_kihi (int mv, int depth, board * B)
{
    int i, j;

	if (mv != B->killer1)
	{
		B->killer2 = B->killer1;
		B->killer1 = mv;
	};

	if ((history [FROM(mv)][TO(mv)] += depth * depth) >= 60000)
	{
		for (i = 0; i < 64; i ++)
		{
			for (j = 0; j < 64; j ++)
			{
				history [i][j] >>= 1;
			};
		};
	};

	return 0;
};


inline pv_t * is_it_pv (U64 key, int ply)
{
    int i, j = 0;
    U64 _key = S->pv_start;

    for (i = 0; i < ply; i ++)
	{
	    j = _key & (PV_SIZE - 1);
		_key = pv [j].key_new;
	};

    if (key == _key) return &pv[j];

	return NULL;
};

void pv_write (board * B, int move)
{
    int ind;

    if (!move) move = B->cmove;

    ind = B->hash & (PV_SIZE - 1);

    pv [ind].key     = B->hash;
    pv [ind].key_new = (B + 1)->hash;
    pv [ind].mv      = move;
};
